<template>
    <div class="row mt-3">
        <div class="col-10"></div>
        <div class="col-2 text-end p-0">
            <button v-show="ocultarBotonAlta" type="button" class="btn btn-secondary mx-1 mt-4 p-1 px-2 mb-4"
                @click="agregarLiq()">
                <i class="bi bi-plus-square mx-1 fonts-sm p-0"></i> NUEVO
            </button>
        </div>
    </div>
    <table class="table  table-striped" v-if="liquidacionesStore.listadoLiquidaciones.length > 0">
        <thead>
            <tr>
                <th scope="col">Periodo</th>
                <th scope="col">Nro Liq</th>
                <th scope="col">Descripción</th>
                <th scope="col">Estado</th>

                <th scope="col">Opciones</th>

            </tr>
        </thead>
        <tbody>
            <tr v-for="liq in liquidacionesStore.listadoLiquidaciones" :key="liq.id_liq_resu">
                <td v-text="liq.perimmaa"></td>
                <td v-text="liq.nro_liq"></td>
                <td v-text="liq.d_tipo_liq"></td>
                <td v-text="liq.d_estado"></td>


                <td>
                    <!--<router-link alt="Borrar" title="Borrar" :to="{
                    name: 'Borrar-liq',
                    params: { id: liq.nro_liq },
                }">-->
                    <button v-show="liq.estado === 'I' || liq.estado === 'P'"
                        class="btn btn-borrar-table  mx-2 text-uppercase p-0 px-2 fs-5 mb-2 mt-0" alt="Borrar" title="Borrar"
                        @click="borrarLiq(Number(liq.id_liq_resu))">
                        <i class="fa-solid fa-trash-can"></i>
                    </button>


                    <!--</router-link>-->
                    <button v-show="liq.estado === 'P'" class="btn btn-principal btn-sm p-1 mb-2 mt-0 mx-1"
                        alt="Cerrar liquidación" title="Cerrar liquidación" @click="cerrarLiq(Number(liq.id_liq_resu))">
                        <svg id="" data-name="Capa 1" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 91.84 99.26"
                            style="width:22px;">
                            <path fill="#fff"
                                d="M32.09,59.74l-2.53-.65v-16c4.05.8,6.75,3.17,7.48,6.64l.23,1.07h9.79l-.15-1.48C46.05,41,39.3,35.13,29.56,34.08v-6H21.75v6.22c-9.64,1.59-16,8.16-16,16.65,0,7.62,5.13,13.31,14.05,15.6l2,.53V84.14c-4.25-1-7-3.55-7.78-7.06L13.75,76H4l.13,1.47C4.91,86,11.77,92.13,21.75,93.3v6.08h7.81V93.3c11.16-1.3,18-7.88,18-17.41C47.59,67.6,42.67,62.47,32.09,59.74ZM21.75,57.05c-4.07-1.19-6.13-3.35-6.13-6.43,0-3.45,2.31-6.13,6.13-7.27Zm7.81,27.33V69h0c7.09,1.78,8.06,4.59,8.06,7.36C37.65,80.63,34.66,83.55,29.56,84.38Z"
                                transform="translate(-4.02 -0.62)" />
                            <path fill="#fff"
                                d="M71.26.62A24.72,24.72,0,1,0,96,25.34,24.73,24.73,0,0,0,71.26.62ZM79.53,39l-4.84-6.14c-1.29-1.58-2.38-3.1-3.54-4.74H71c-1.09,1.64-2.25,3.1-3.47,4.74L62.78,39h-6.6L67.89,25.06,56.72,11.7h6.67l4.7,5.86c1.23,1.52,2.25,2.93,3.34,4.45h.2c1.09-1.63,2.18-3,3.27-4.5l4.63-5.81H86L74.76,24.89,86.33,39Z"
                                transform="translate(-4.02 -0.62)" />
                        </svg>
                    </button>
                </td>
            </tr>
        </tbody>
    </table>
    <div v-else class="alert alert-secondary" role="alert">
        No hay elementos para mostrar
    </div>
</template>
  
<script setup lang="ts">

//librerias
import { onMounted, reactive, computed } from "vue";
import { useRoute, useRouter } from "vue-router";
import Swal from "sweetalert2/dist/sweetalert2.js";
import { AxiosError } from "axios";
import http from "@/http";
import { loading, urlApi, isEmpty } from "@/shared.js";

//store
import { useLiquidacionesStore } from "@/stores/Liquidaciones/liquidaciones";
import type Liquidacion from "@/entities/Liquidaciones/Liquidacion";


const route = useRoute();
const router = useRouter();
const liquidacionesStore = useLiquidacionesStore();
var data = reactive({
    liqActual: undefined as Liquidacion | undefined,
    //isLoading: true,
});

const ocultarBotonAlta = computed(() => {
    return (data.liqActual?.estado == 'C' || data.liqActual === undefined)
})


onMounted(async () => {
    loading.show();
    await liquidacionesStore.updateListadoLiquidaciones();
    data.liqActual = await liquidacionesStore.getLiqResulActual();
    loading.hide();
   
})

function cerrarLiq(id: Number) {

    Swal.fire({
        icon: "question",
        title: "Confirmaci&oacute;n",
        html: "¿Confirma cerrar la liquidaci&oacute;n?",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Confirmar",
        cancelButtonText: "Cancelar",
    }).then(async (result) => {
        if (result.isConfirmed) {


            try {

                var rta = await http.post(urlApi + "modifyLiqResu", {
                    id_liq_resu: id,
                });
                if (rta.data.id_liq_resu_out != "") {

                    await liquidacionesStore.updateListadoLiquidaciones();
                    Swal.fire({
                        icon: "success",
                        text: rta.data.mensaje + " Se cerro la liquidación.",
                    })

                } else {

                    Swal.fire({
                        icon: "error",
                        text: rta.data.mensaje,
                    });

                }
            } catch (error: any) {
                var mensaje: string = error.message;

                if (error instanceof AxiosError) {
                    mensaje = error.response?.data.res.mensaje;
                }
                Swal.fire({
                    icon: "error",
                    text: mensaje,
                });
            }
        }
    });
}


function borrarLiq(id: Number) {


    Swal.fire({
        icon: "question",
        title: "Confirmaci&oacute;n",
        html: "¿Confirma eliminar la  liquidaci&oacute;n? Esta acci&oacute;n no podr&aacute; ser revertida.",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Confirmar",
        cancelButtonText: "Cancelar",
    }).then(async (result) => {
        if (result.isConfirmed) {
            loading.show();
            try {
                var rta = await http.post(urlApi + "deleteLiqResu", {
                    id_liq_resu: id,
                });

                console.log(rta.data);
                if (rta.data.id_liq_resu != "") {
                    await liquidacionesStore.updateListadoLiquidaciones();
                    data.liqActual = await liquidacionesStore.getLiqResulActual();
                    Swal.fire({
                        icon: "success",
                        text: rta.data.mensaje + " Se borro la liquidación.",
                    })

                } else {
                    Swal.fire({
                        icon: "error",
                        text: rta.data.mensaje,
                    });

                }
            } catch (error: any) {
                var mensaje: string = error.message;

                if (error instanceof AxiosError) {
                    mensaje = error.response?.data.res.mensaje;
                }
                Swal.fire({
                    icon: "error",
                    text: mensaje,
                });
            }
            loading.hide();
        }
    });
}

function agregarLiq() {

    Swal.fire({
        icon: "question",
        title: "Confirmaci&oacute;n",
        html: "¿Desea agregar una nueva liquidaci&oacute;n?",
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Confirmar",
        cancelButtonText: "Cancelar",
    }).then(async (result) => {
        if (result.isConfirmed) {
            loading.show();
            try {
                var rta = await http.post(urlApi + "addLiqResu");

                console.log(rta.data);
                if (rta.data.id_liq_resu != "") {
                    await liquidacionesStore.updateListadoLiquidaciones();
                    data.liqActual = await liquidacionesStore.getLiqResulActual();
                    Swal.fire({
                        icon: "success",
                        text: rta.data.mensaje + " Se creo la nueva liquidación.",
                    })

                } else {
                    Swal.fire({
                        icon: "error",
                        text: rta.data.mensaje,
                    });

                }
            } catch (error: any) {
                var mensaje: string = error.message;

                if (error instanceof AxiosError) {
                    mensaje = error.response?.data.res.mensaje;
                }
                Swal.fire({
                    icon: "error",
                    text: mensaje,
                });
            }
            loading.hide();
        }
    });

}



</script>
  